VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form Form1 
   Caption         =   "PDF Report Generator Demo"
   ClientHeight    =   10050
   ClientLeft      =   135
   ClientTop       =   510
   ClientWidth     =   11625
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   10050
   ScaleWidth      =   11625
   Begin VB.CommandButton GeneratePDF 
      Caption         =   "Generate PDF"
      Height          =   495
      Left            =   8640
      TabIndex        =   11
      Top             =   9360
      Width           =   2775
   End
   Begin VB.Frame Frame1 
      Height          =   1695
      Left            =   3480
      TabIndex        =   6
      Top             =   7440
      Width           =   7935
      Begin VB.CheckBox TransferAsBuffer 
         Caption         =   "Transfer as buffer"
         Height          =   255
         Left            =   240
         TabIndex        =   9
         Top             =   1200
         Width           =   3135
      End
      Begin VB.TextBox OutputFile 
         Height          =   375
         Left            =   240
         TabIndex        =   8
         Text            =   "test.pdf"
         Top             =   600
         Width           =   7575
      End
      Begin VB.Label status 
         Height          =   255
         Left            =   5640
         TabIndex        =   10
         Top             =   1200
         Width           =   2175
      End
      Begin VB.Label Label4 
         Caption         =   "Output File Name (*.pdf)"
         Height          =   255
         Left            =   240
         TabIndex        =   7
         Top             =   240
         Width           =   2295
      End
   End
   Begin VB.TextBox TextInput 
      Height          =   975
      Left            =   3480
      MultiLine       =   -1  'True
      TabIndex        =   3
      Top             =   6240
      Width           =   7935
   End
   Begin VB.TextBox rtf 
      Height          =   5415
      Left            =   3480
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   2
      Top             =   360
      Width           =   7935
   End
   Begin VB.ListBox fct 
      Height          =   9420
      Left            =   120
      TabIndex        =   0
      Top             =   360
      Width           =   3135
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   3960
      Top             =   4560
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Label Label3 
      Caption         =   "Intermediate RTF Code"
      Height          =   255
      Left            =   3480
      TabIndex        =   5
      Top             =   120
      Width           =   3255
   End
   Begin VB.Label Label2 
      Caption         =   "Text Input Area"
      Height          =   255
      Left            =   3480
      TabIndex        =   4
      Top             =   6000
      Width           =   2775
   End
   Begin VB.Label Label1 
      Caption         =   "Select a Function Call"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   3135
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Sub Text1_Change()

End Sub


Private Sub fct_Click()
   Dim CurFct As Integer
   CurFct = fct.ListIndex
   CallFunction (CurFct)
End Sub


Private Sub Form_Load()
   
   ' Load the avaialble function names in the list box
    fct.AddItem "New Document", ID_NEW
    fct.AddItem "Initialize Section", ID_INIT_SECT
    fct.AddItem "Begin Section Text", ID_BEGIN_TEXT
    fct.AddItem "Reset Character Properties", ID_RESET_CHAR_PROP
    fct.AddItem "Set Font...", ID_SET_FONT
    fct.AddItem "Set Character Style Id", ID_CHAR_STYLE_ID
    fct.AddItem "Reset Paragraph Properties", ID_RESET_PARA_PROP
    fct.AddItem "Paragraph Centering", ID_PARA_CENTER
    fct.AddItem "Paragraph Right Justification", ID_PARA_RIGHT
    fct.AddItem "Paragraph Double Spacing", ID_PARA_DOUBLE_SPACE
    fct.AddItem "Paragraph Border", ID_PARA_BORDER
    fct.AddItem "Paragraph Indents", ID_PARA_INDENT
    fct.AddItem "Paragraph Spacing", ID_PARA_SPACE
    fct.AddItem "Paragraph Shading", ID_PARA_SHADE
    fct.AddItem "Paragraph Bullet", ID_PARA_BULLET
    fct.AddItem "Paragraph Numbering", ID_PARA_NUMBERING
    fct.AddItem "Paragraph Tab Stops", ID_PARA_TAB_STOP
    fct.AddItem "Set Paragraph Style Id", ID_PARA_STYLE_ID
    fct.AddItem "Insert Text...", ID_INSERT_TEXT
    fct.AddItem "Insert Table", ID_INSERT_TABLE
    fct.AddItem "Insert a Picture file...", ID_INSERT_PICT
    fct.AddItem "Insert a Linked Picture file...", ID_INSERT_LINK_PICT
    fct.AddItem "Set Paper Size", ID_PAPER
    fct.AddItem "Set Page Margin", ID_MARGIN
    fct.AddItem "Set Section Information", ID_SECT_INFO
    fct.AddItem "Begin Header Group", ID_BEGIN_HDR
    fct.AddItem "End Header Group", ID_END_HDR
    fct.AddItem "Begin Footer Group", ID_BEGIN_FTR
    fct.AddItem "End Footer Group", ID_END_FTR
    fct.AddItem "Begin Stylesheet", ID_BEGIN_STYLESHEET
    fct.AddItem "Begin a Stylesheet Item", ID_BEGIN_STYLEITEM
    fct.AddItem "End a Stylesheet Item", ID_END_STYLEITEM
    fct.AddItem "End Stylesheet", ID_END_STYLESHEET
    fct.AddItem "Begin Frame Group", ID_BEGIN_FRAME
    fct.AddItem "End Frame Group", ID_END_FRAME
    fct.AddItem "Begin a Text Box Group", ID_BEGIN_TEXT_BOX
    fct.AddItem "End Text Box Group", ID_END_TEXT_BOX
    fct.AddItem "Draw a Rectangle", ID_DRAW_RECT
    fct.AddItem "Draw a Line", ID_DRAW_LINE
    fct.AddItem "Insert a page break", ID_PAGE_BREAK
    fct.AddItem "Insert a section break", ID_SECT_BREAK
    fct.AddItem " ", ID_OTHER
      
    ' begin the first report
    DocId = 0
    CallFunction (ID_NEW)
    
    TextInput.text = "This is sample text"
        
End Sub


Rem ******************************************************************************
Rem  CallFunction
Rem  Call the specified API function.
Rem ******************************************************************************/
Private Sub CallFunction(ByVal FunctionId As Integer)

    Dim TempString As String
    Dim result As Long
    Dim CurStyle As Long
    Dim temp As Long

    Select Case FunctionId
        Case ID_NEW                       ' new reporting session
           If RepId Then Call PdgEndSession(RepId)  ' end the previous document
           RepId = PdgNewSession()        ' start new reporting session
           DocId = PdgNewDocObject(RepId) ' create document id for the reporting session
           
        Case ID_BEGIN_STYLESHEET          ' begin the stylesheet group
           temp = RcgBeginStyleSheet(DocId)

        Case ID_BEGIN_STYLEITEM           ' begin a stylesheet item
           temp = RcgBeginStyleItem(DocId, StyleItemCount, SSTYPE_PARA, "Normal")
           StyleItemCount = StyleItemCount + 1
           

        Case ID_END_STYLEITEM              ' end current stylesheet item
           temp = RcgEndStyleItem(DocId)

        Case ID_END_STYLESHEET             ' end current stylesheet group
           temp = RcgEndStyleSheet(DocId)


        Case ID_PAPER                     ' set paper size to 8.5 by 11 inches
           temp = RcgPaper(DocId, (8.5 * 1440), (11 * 1440), False)
           

        Case ID_MARGIN                     ' set 1 inche margin around
           temp = RcgMargin(DocId, 1440, 1440, 1440, 1440, -1, -1)
           

        Case ID_INIT_SECT                 ' initialize the section
           temp = RcgInitSect(DocId)

        Case ID_SECT_INFO                 ' set the initial page number at 30
           temp = RcgSectInfo(DocId, 1, 0, True, 30)

        Case ID_BEGIN_HDR                 ' begin the header group
           temp = RcgBeginHdrFtr(DocId, RCG_HDR)

        Case ID_END_HDR                   ' end the header group
           temp = RcgEndHdrFtr(DocId)

        Case ID_BEGIN_FTR                 ' begin the footer group
           temp = RcgBeginHdrFtr(DocId, RCG_FTR)

        Case ID_END_FTR                   ' end the footer group
           temp = RcgEndHdrFtr(DocId)

        Case ID_BEGIN_FRAME               ' begin the footer group
           temp = RcgBeginFrame(DocId, True, 2000, 2000, 4000, 4000)

        Case ID_END_FRAME                 ' end the footer group
           temp = RcgEndFrame(DocId)

        Case ID_BEGIN_TEXT_BOX            ' begin the text box group
           temp = RcgBeginTextBox(DocId, True, 1500, 1500, 2000, 2000, -1, &HFFFFFF, 0, 20, False)
           

        Case ID_END_TEXT_BOX              ' end the text box  group
           temp = RcgEndTextBox(DocId)

        Case ID_DRAW_RECT                 ' draw a rectangle
           temp = RcgDrawRect(DocId, True, 3500, 3500, 2000, 2000, -1, &HFFFF, 0, 20, False)
           

        Case ID_DRAW_LINE                 ' draw a line
           temp = RcgDrawLine(DocId, True, 2500, 2500, 3500, 3500, -1, &HFF, 60)
           

        Case ID_PAGE_BREAK                 ' page break
           temp = RcgInsertBreak(DocId, RCG_BREAK_PAGE)

        Case ID_SECT_BREAK                 ' page break
           temp = RcgInsertBreak(DocId, RCG_BREAK_SECT)

        Case ID_BEGIN_TEXT                ' text begins
           temp = RcgBeginSectText(DocId)

        Case ID_RESET_CHAR_PROP           ' reset the character properties
           temp = RcgResetTextProp(DocId)

        Case ID_RESET_PARA_PROP           ' reset the paragraph properties
           temp = RcgResetParaProp(DocId)

        Case ID_SET_FONT
           CommonDialog1.flags = cdlCFBoth
           CommonDialog1.CancelError = True

           On Error GoTo cancelled
           CommonDialog1.ShowFont
           On Error GoTo 0

           CurStyle = 0
           If (CommonDialog1.FontBold) Then CurStyle = CurStyle Or RCG_BOLD
           If (CommonDialog1.FontItalic) Then CurStyle = CurStyle Or RCG_ITALIC
           If (CommonDialog1.FontUnderline) Then CurStyle = CurStyle Or RCG_ULINE
           If (CommonDialog1.FontStrikethru) Then CurStyle = CurStyle Or RCG_STRIKE
        
           temp = RcgTextFont(DocId, CommonDialog1.FontName, CommonDialog1.FontSize, CurStyle, True)
           temp = RcgTextColor(DocId, CommonDialog1.Color, True)
           
        Case ID_CHAR_STYLE_ID             ' specify the character style id
           temp = RcgCharStyleId(DocId, 1)

        Case ID_PARA_CENTER               ' specify the paragraph centering
           temp = RcgParaFlags(DocId, RCG_CENTER)

        Case ID_PARA_RIGHT               ' specify the paragraph right justification
           temp = RcgParaFlags(DocId, RCG_RIGHT)

        Case ID_PARA_DOUBLE_SPACE        ' specify the paragraph double spacing
           temp = RcgParaFlags(DocId, RCG_DOUBLE_SPACE)

        Case ID_PARA_BORDER              ' Apply single width paragraph border
           temp = RcgParaFlags(DocId, RCG_PARA_BOX)

        Case ID_PARA_INDENT              ' Apply paragraph indentation
           temp = RcgParaIndent(DocId, 1440, 1440, 1440)

        Case ID_PARA_SPACE               ' Apply paragraph spacing
           temp = RcgParaSpace(DocId, 720, 720, 400)

        Case ID_PARA_SHADE               ' Apply paragraph shading
           temp = RcgParaShadeColor(DocId, 30, 0)

        Case ID_PARA_BULLET               ' Apply paragraph bullet
           temp = RcgParaIndent(DocId, 720, 720, -720)
           temp = RcgParaBullet(DocId, True, BLT_ROUND, 0, 1, 0, 0, 0)
           

        Case ID_PARA_NUMBERING           ' Apply paragraph Numbering
           temp = RcgParaIndent(DocId, 720, 720, -720)
           temp = RcgParaBullet(DocId, False, NBR_DEC, 0, 1, "(", ")", 0)
           

        Case ID_PARA_TAB_STOP            ' create paragraph tab stops
           temp = RcgParaTabStop(DocId, 0, 1440, 0) ' at one inch
           temp = RcgParaTabStop(DocId, 0, 3 * 1440, 0) ' at 3 inch
           temp = RcgParaTabStop(DocId, TAB_RIGHT, 5 * 1440, TAB_DOT) ' right tab with dot leader at 5 inches
           

        Case ID_PARA_STYLE_ID             ' specify the paragraph style id
           temp = RcgParaStyleId(DocId, 1)

        Case ID_INSERT_TEXT
           temp = RcgInsertText(DocId, TextInput.text)   ' insert the text into the rtf buffer
           

        Case ID_INSERT_TABLE
           InsertTable
           

        Case ID_INSERT_PICT
           CommonDialog1.DefaultExt = "bmp"
           CommonDialog1.Filter = "Bitmap File(*.BMP)|*.BMP|Windows Metafile(*.WMF)|*.WMF|"
           CommonDialog1.CancelError = True
           
           On Error GoTo cancelled
           CommonDialog1.ShowOpen
           On Error GoTo 0
           temp = RcgInsertPictFile(DocId, CommonDialog1.FileName, 0, 0, False) ' save the code the file


        Case ID_INSERT_LINK_PICT
           CommonDialog1.DefaultExt = "bmp"
           CommonDialog1.Filter = "Bitmap File(*.BMP)|*.BMP|Windows Metafile(*.WMF)|*.WMF|"
           CommonDialog1.CancelError = True
           
           On Error GoTo cancelled
           CommonDialog1.ShowOpen
           On Error GoTo 0
           temp = RcgInsertPictFile(DocId, CommonDialog1.FileName, 0, 0, True)
           

        Case ID_OTHER                        ' this code is for miscellaneous testing
           TestCode
           
    End Select

    If (DocId) Then ShowRtfCode   ' refresh the code text box

Exit Sub

cancelled:

End Sub

'******************************************************************************
'   ShowRtfCode:
'   Show the rtf code so far generated.
'******************************************************************************/
Private Sub ShowRtfCode()

    Dim hCode As Long
    Dim pCode As String
    Dim DataLen As Long
    Dim temp As Long

    hCode = RcgGetData(DocId, DataLen)
    
    pCode = Space$(DataLen + 1) ' allocate space for the string
    temp = RcgHandleToStr(pCode, DataLen, hCode)

    rtf.text = pCode

End Sub

'******************************************************************************
'   InsertTable:
'   Insert a table. This function creates a table of 2 columns and 3 rows.
'   The first row contains the header.  The table list the name and price of
'    a couple products.
'******************************************************************************/
Private Sub InsertTable()
    Dim temp As Long

    ' Create the header row.
    temp = RcgBeginTableRow(DocId, 0, 0, RCG_CENTER, False, 0)
    temp = RcgNextCellInfo(DocId, 3 * 1440, 0, 30, &HFFFFFF, 20, 40, 20, 40, 0)
    temp = RcgNextCellInfo(DocId, 1440, 0, 30, &HFFFFFF, 40, 20, 20, 40, 0)

    ' row 1 col 1
    temp = RcgBeginCellText(DocId)
    temp = RcgResetTextProp(DocId)
    temp = RcgTextFont(DocId, "", 0, RCG_BOLD, True)
    temp = RcgInsertText(DocId, "Products")
    temp = RcgEndCellText(DocId)

    ' row 1 col 2
    temp = RcgBeginCellText(DocId)
    temp = RcgResetTextProp(DocId)
    temp = RcgTextFont(DocId, "", 0, RCG_BOLD, True)
    temp = RcgInsertText(DocId, "Price")
    temp = RcgEndCellText(DocId)

    temp = RcgEndTableRow(DocId)

    ' create the second row
    temp = RcgBeginTableRow(DocId, 0, 0, RCG_CENTER, False, 0)
    temp = RcgNextCellInfo(DocId, 3 * 1440, 0, 0, &HFFFFFF, 20, 40, 40, 20, 0)
    temp = RcgNextCellInfo(DocId, 1440, 0, 0, &HFFFFFF, 40, 20, 40, 20, 0)

    ' row 2 col 1
    temp = RcgBeginCellText(DocId)
    temp = RcgResetTextProp(DocId)
    temp = RcgInsertText(DocId, "TE Developer's Kit")
    temp = RcgEndCellText(DocId)

    ' row 2 col 2
    temp = RcgBeginCellText(DocId)
    temp = RcgResetTextProp(DocId)
    temp = RcgInsertText(DocId, "$439.00")
    temp = RcgEndCellText(DocId)

    temp = RcgEndTableRow(DocId)

    ' create the third row
    temp = RcgBeginTableRow(DocId, 0, 0, RCG_CENTER, False, 0)
    temp = RcgNextCellInfo(DocId, 3 * 1440, 0, 0, &HFFFFFF, 20, 40, 20, 20, 0)
    temp = RcgNextCellInfo(DocId, 1440, 0, 0, &HFFFFFF, 40, 20, 20, 20, 0)

    ' row 2 col 1
    temp = RcgBeginCellText(DocId)
    temp = RcgResetTextProp(DocId)
    temp = RcgInsertText(DocId, "ReportEase Plus")
    temp = RcgEndCellText(DocId)

    ' row 2 col 2
    temp = RcgBeginCellText(DocId)
    temp = RcgResetTextProp(DocId)
    temp = RcgInsertText(DocId, "$459.00")
    temp = RcgEndCellText(DocId)

    temp = RcgEndTableRow(DocId)

End Sub

'******************************************************************************
'   TestCode:
'   Additional test code.
'******************************************************************************/
Private Sub TestCode()
  Dim RepId As Long
  Dim DocId As Long
  Dim result As Integer
  
  RepId = PdgNewSession() ' start new report session
  
  DocId = PdgNewDocObject(RepId) ' begin new document, and return
                             'a document 'handle
  result = RcgInitSect(DocId) ' begin first section
  result = RcgBeginSectText(DocId)  ' begin the text for
                                    ' the section
  result = RcgTextFont(DocId, "Times New Roman", 12, RCG_BOLD, True)
  result = RcgInsertText(DocId, "This is the first line" + Chr$(13) + Chr$(10))   ' Ascii 13/10 pair terminates
                                 'the paragraph
  result = RcgTextFont(DocId, "Arial", 12, RCG_BOLD, False)
  result = RcgParaFlags(DocId, RCG_CENTER)
  result = RcgInsertText(DocId, "This is the second paragraph" + Chr$(13) + Chr$(10))
  result = RcgSaveFile(DocId, "test.rtf") ' save the rtf code to
                                          'the file
  result = PdgGenerateReportFile(RepId, DocId, "test.pdf") ' generate PDF
                                          
  result = PdgEndSession(RepId) ' free the current report handle
 
End Sub


Private Sub GeneratePDF_Click()
   Dim OutString As String
   
   Status.Caption = "Generating..."
   Status.Refresh
   
   
   Call PdgSetBoolProp(RepId, PGPROP_EXACT_TEXT_PLACEMENT, True)
   
   If TransferAsBuffer.Value = 1 Then  ' do conversion after reading the file in a string
     
     hMem = PdgGenerateReportBuffer(RepId, DocId, OutSize)
     If (hMem <> 0) Then
        OutString = Space$(OutSize + 1) ' allocate space for the output string
        Call PdgHandleToStr(OutString, OutSize, hMem)
        If WriteFile(OutputFile.text, OutString, OutSize) Then result = True
     End If
   Else              ' do the file conversion
     If (PdgGenerateReportFile(RepId, DocId, OutputFile.text)) Then result = True
   End If
      
   If (result) Then Status.Caption = "Done!" Else Status.Caption = "Error"

End Sub

Function WriteFile(ByVal FileName As String, DataString As String, ByVal DataSize) As Boolean
   Dim iFile As Integer

   WriteFile = False
      
   On Error GoTo OutErrorHandler
   Kill FileName   ' delete any existing file
   
   Rem open the input file
   iFile = 1
   ErrorCode = 0
   On Error GoTo OutErrorHandler
   Open FileName For Binary Access Write As iFile
   On Error GoTo 0
   If ErrorCode Then
      MsgBox "Output file can not be opened!"
      Exit Function
   End If
   
   Put #iFile, , DataString
   
   Close #iFile
   
   WriteFile = True
   
   Exit Function

OutErrorHandler:
   ErrorCode = Err
   Resume Next

   
End Function

